package com.goldencode.p2j.persist;

import org.hibernate.dialect.function.SQLFunction;
import org.hibernate.engine.SessionFactoryImplementor;

import java.util.List;

public class EFunction extends CommonSafeCompareFunction implements SQLFunction
{
   @Override
   protected String equalRender()
   {
      //            true
      return VAL_TRUE;
   }

   @Override
   protected String notEqualRender()
   {
      //            false
      return VAL_FALSE;
   }

   @Override
   protected String falseNullableRender(String arg)
   {
      //            ((arg IS NOT NULL) AND (arg = false))
      StringBuilder buf = new StringBuilder();
      buf.append("((").append(arg).append(" IS NOT NULL) AND (").append(arg).append(" = false)");
      return buf.toString();
   }

   @Override
   protected String trueNullableRender(String arg)
   {
      //            ((arg IS NOT NULL) AND (arg = true))
      StringBuilder buf = new StringBuilder();
      buf.append("((").append(arg).append(" IS NOT NULL) AND (").append(arg).append(" = true)");
      return buf.toString();
   }

   @Override
   protected String nullNullableRender(String arg)
   {
      //            (arg IS NULL)
      StringBuilder buf = new StringBuilder();
      buf.append("(").append(arg).append(" IS NULL)");
      return buf.toString();
   }

   @Override
   protected String trueNotNullableRender(String arg)
   {
      //            (arg = true)
      StringBuilder buf = new StringBuilder();
      buf.append("(").append(arg).append(" = true)");
      return buf.toString();
   }

   @Override
   protected String falseNotNullableRender(String arg)
   {
      //            (arg = false)
      StringBuilder buf = new StringBuilder();
      buf.append("(").append(arg).append(" = false)");
      return buf.toString();
   }

   @Override
   protected String bothNotNullableRender(String arg1, String arg2)
   {
      //            (arg1 = arg2)
      StringBuilder buf = new StringBuilder();
      buf.append("(").append(arg1).append(" = ").append(arg2).append(")");
      return buf.toString();
   }

   @Override
   protected String firstNotNullableRender(String arg1, String arg2)
   {
//            ((arg2 IS NOT NULL) AND (arg1 = arg2))
      StringBuilder buf = new StringBuilder();
      buf.append("((").append(arg2).
              append(" IS NOT NULL) AND (").
              append(arg1).append(" = ").append(arg2).
              append("))");
      return buf.toString();
   }

   @Override
   protected String bothNullableRender(String arg1, String arg2)
   {
//            (CASE
//            WHEN (arg1 IS NULL) THEN (arg2 IS NULL)
//            ELSE ((arg2 IS NOT NULL) AND (arg1 = arg2))
//            END)

      StringBuilder buf = new StringBuilder();
      buf.append("(CASE WHEN (").append(arg1).append(" IS NULL) THEN (").
              append(arg2).append(" IS NULL) ELSE ((").append(arg2).
              append(" IS NOT NULL) AND (").append(arg1).append(" = ").append(arg2).append(")) END)");
      return buf.toString();
   }
}